# Class CubeVectorDataGeom

java.lang.Object
uk.ac.starlink.ttools.plot2.geom.CubeVectorDataGeom

All Implemented Interfaces:
  `DataGeom`

public class CubeVectorDataGeom extends Object implements DataGeom
DataGeom for working with 3-d space that uses a 3-vector as its input.

Since:
  18 Jan 2024
Author:
  Mark Taylor

## Field Summary

Fields
Modifier and Type
Field
Description
`static CubeVectorDataGeom`
`INSTANCE`
Singleton instance.
`static final FixedLengthVectorCoord`
`XYZ_COORD`
3-vector coordinate.

## Method Summary

Modifier and Type
Method
Description
`int`
`getDataDimCount()`
Returns 3.
`Coord[]`
`getPosCoords()`
Returns the definitions for the user-supplied coordinates that indicate plot positions.
`String`
`getVariantName()`
Returns a label for this DataGeom.
`boolean`
`readDataPos(Tuple tuple, int ic, double[] dpos)`
Determines the positional coordinates in data space for a supplied tuple.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### XYZ_COORD

public static final FixedLengthVectorCoord XYZ_COORD
3-vector coordinate.

### INSTANCE

public static CubeVectorDataGeom INSTANCE
Singleton instance.

## Method Details

### getDataDimCount

public int getDataDimCount()
Returns 3.

Specified by:
  `getDataDimCount` in interface `DataGeom`
Returns:
  number of elements in data space coordinate array

### getVariantName

public String getVariantName()
Description copied from interface: `DataGeom`
Returns a label for this DataGeom. It may be used to distinguish from other geoms used in the same plot type, so for instance call it "Cartesian" or "Polar" rather than "Plane" if it's X,Y.

Specified by:
  `getVariantName` in interface `DataGeom`
Returns:
  user-directed input coordinate type name

### getPosCoords

public Coord[] getPosCoords()
Description copied from interface: `DataGeom`
Returns the definitions for the user-supplied coordinates that indicate plot positions.

Specified by:
  `getPosCoords` in interface `DataGeom`
Returns:
  coordinate quantity array for this geometry

### readDataPos

public boolean readDataPos(Tuple tuple, int ic, double[] dpos)
Description copied from interface: `DataGeom`
Determines the positional coordinates in data space for a supplied tuple.

A parameter supplies the index of the field in the tuple at which the positional coordinate(s) can be found. Each position is represented by `DataGeom.getPosCoords()` columns of the tuple. By convention positions are at the start of the tuple, so if there is one position in the tuple it will be at icol=0, and there are multiple positions the N'th one will be at icol=N*getPosCoords().

An array of (at least) `DataGeom.getDataDimCount()` elements is supplied, and on success the data space coordinate values are written into it.

Specified by:
  `readDataPos` in interface `DataGeom`
Parameters:
  `tuple` - coordinate tuple
  `ic` - column index in `tuple` at which the positional information starts
  `dpos` - array into which data space coordinates are written
Returns:
  true iff conversion was successful